class OSBigBiogel expands BigBiogel;

simulated function SetWall(vector HitNormal, Actor Wall)
{
	Super.SetWall(HitNormal, Wall);
	if ( Level.NetMode != NM_DedicatedServer /*&& class'MonsterHunt.uiweapons'.default.busedecals */)
		spawn(class'BioMark',,,Location, rotator(SurfaceNormal));
}

function Timer()
{
	local GreenGelPuff f;

	f = spawn(class'GreenGelPuff',,,Location + SurfaceNormal*8); 
	if ( f != None)
	{
		f.DrawScale = DrawScale*2.0;
		f.numBlobs = numBio;
		if ( numBio > 0 )
			f.SurfaceNormal = SurfaceNormal;
		PlaySound (MiscSound,,3.0*DrawScale);
		if ( (Mover(Base) != None) && Mover(Base).bDamageTriggered )
			Base.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), '');
		HurtRadius(damage * Drawscale, DrawScale * 120, 'corroded', MomentumTransfer * Drawscale, Location);
	}
	Destroy();
}

function DropDrip()
{
	local BioGel Gel;

	PlaySound(SpawnSound);  // Dripping Sound
	if ( Owner != None )
		Gel = Spawn(class'OSBioDrop', Pawn(Owner),,Location-Vect(0,0,1)*10);
	if ( Gel != None )
		Gel.DrawScale = DrawScale * 0.5;  
}

auto state Flying
{
	simulated function BeginState()
	{
		local Vector viewDir;

		if ( Role == ROLE_Authority )
		{
			Velocity = Vector(Rotation) * Speed;
			Velocity.z += 120;
			if( Region.zone.bWaterZone )
				Velocity=Velocity*0.7;
		}
		if ( Level.NetMode != NM_DedicatedServer )
			RandSpin(100000);
		LoopAnim('Flying',0.4);
		bOnGround=False;
		PlaySound(SpawnSound);
	}
}

/*
state OnSurface
{
	simulated function BeginState()
	{
		wallTime = DrawScale*5+2;
		if ( Mover(Base) != None )
		{
			BaseOffset = VSize(Location - Base.Location);
			SetTimer(0.2, true);
		}
		else 
			SetTimer(wallTime, false);
	}

	simulated function Timer()
	{
		if ( Mover(Base) != None )
		{
			WallTime -= 0.2;
			if ( WallTime < 0.15 )
				Global.Timer();
			else if ( VSize(Location - Base.Location) > BaseOffset + 4 )
				Global.Timer();
		}
		else
			Global.Timer();
	}
}
*/
state OnSurface
{

	simulated function CheckSurface()
	{
		local float DotProduct;

		DotProduct = SurfaceNormal dot vect(0,0,-1);
		If( DotProduct > 0.7 )
			PlayAnim('Drip',0.1);
		else if (DotProduct > -0.5) 
			PlayAnim('Slide',0.2);
	}

	function Timer()
	{
		if ( Mover(Base) != None )
		{
			WallTime -= 0.2;
			if ( WallTime < 0.15 )
				Global.Timer();
			else if ( VSize(Location - Base.Location) > BaseOffset + 4 )
				Global.Timer();
		}
		else
			Global.Timer();
	}

	function BeginState()
	{
		wallTime = DrawScale*5+2;
		if ( Mover(Base) != None )
		{
			BaseOffset = VSize(Location - Base.Location);
			SetTimer(0.2, true);
		}
		else 
			SetTimer(wallTime, false);
	}

	simulated function AnimEnd()
	{
		if ( !bCheckedSurface && (DrawScale > 1.0) )
			CheckSurface();
		bCheckedSurface = true;
	}
}


defaultproperties
{
     RemoteRole=ROLE_SimulatedProxy
     bNetTemporary=False
}
