//=============================================================================
// osAmplifier.
// bla bla CopyLeft myself
//=============================================================================
class osAmplifier extends TournamentPickup;

var() float AmpMultiplier;
var() sound AmpSound;


function bool HandlePickupQuery( inventory Item ) //We have a clear reason to mock with a red HUD painter?
{
	local OLASMD AS;
	local OLDPistol S;

	if ( item.class == class )
	{
		S = OLDPistol(Pawn(Owner).FindInventoryType(class'OLDPistol'));
		AS = OLASMD(Pawn(Owner).FindInventoryType(class'OLASMD'));
		if ( S == None && AS == None )
			return True;
	}
	return Super.HandlePickupQuery(Item);;
}


event float BotDesireability( pawn Bot )
{
	local OLDPistol D;
	local OLASMD As;

//=== Must remember these
	D = OLDPistol(Bot.FindInventoryType(class'OLDPistol'));
	As = OLASMD(Bot.FindInventoryType(class'OLASMD'));
//=== Interesting syntax

	if ( D == None && As == None ) //if none of them exist
		return -2;
	else							//at least one of them awake my curiosity
		return 1;
	return Super.BotDesireability(Bot);
}

event TravelPreAccept()
{
	local inventory w, w1;

	Super(Pickup).TravelPreAccept();
	w = Pawn(Owner).FindInventoryType(class'OLDPistol');
	if ( w != None )
		OLDPistol(w).Amp = self;
	w1 = Pawn(Owner).FindInventoryType(class'OLASMD');
	if ( w1 != None )
		OLASMD(w1).Amp = self;
}

function inventory SpawnCopy( pawn Other )
{
	local inventory Copy;
	local Inventory I, I1;

	Copy = Super(Pickup).SpawnCopy(Other);
	I = Other.FindInventoryType(class'OLDPistol');
	if ( OLDPistol(I) != None )
		OLDPistol(I).amp = osAmplifier(Copy);

	I1 = Other.FindInventoryType(class'OLASMD');
	if ( OLASMD(I1) != None )
		OLASMD(I1).amp = osAmplifier(Copy);
	return Copy;
}

function float UseCharge(float Amount)
{
	Return 1.0;
}

function UsedUp()
{
	local Inventory I, I1;

	I = Pawn(Owner).FindInventoryType(class'OLDPistol');
	if ( OLDPistol(I) != None )
		OLDPistol(I).amp = None;

	I1 = Pawn(Owner).FindInventoryType(class'OLASMD');
	if ( OLASMD(I1) != None )
		OLASMD(I1).amp = None;
	Super(Pickup).UsedUp();
}

state Activated
{
	function float UseCharge(float Amount)
	{
		local float TempCharge;
		if (AmpMultiplier<1.0) AmpMultiplier=1.0;
	
		if (Charge < Amount) {
			TempCharge = Charge;
			Charge=0;
			Return (AmpMultiplier-1.0)*TempCharge/Amount+1.0;
		}
		Charge = Charge - Amount;
		return AmpMultiplier;
	}

	function Timer()
	{
		Charge -= 2;
		if (Charge<=0) 
		{
			UsedUp();
		}
	}

	function EndState()
	{
		if ( Owner.IsA('PlayerPawn') )
			PlayerPawn(Owner).ClientAdjustGlow(0.1,vect(-100,-20,0));
		Owner.AmbientSound=None;
		Owner.LightType=LT_None;
		Owner.AmbientGlow=0;
		bActive = false;
	}
Begin:
	SetTimer(1.0,True);
	PlaySound(ActivateSound);
	Owner.AmbientSound=AmpSound;
	if ( Owner.IsA('PlayerPawn') )
		PlayerPawn(Owner).ClientAdjustGlow(-0.1,vect(100,20,0));
	Owner.LightType=LT_Steady;
	Owner.LightRadius=6;
	Owner.LightEffect=LE_NonIncidence;
	Owner.LightSaturation=40;
	Owner.LightHue=225;
	Owner.LightBrightness=255;
	Owner.AmbientGlow=255;
}

state DeActivated
{
Begin:
}

defaultproperties
{
     AmpMultiplier=4.000000
     AmpSound=Sound'UnrealShare.Pickups.AmpAct'
     bCanActivate=True
     ExpireMessage="Amplifier is out of power."
     bAutoActivate=True
     bActivatable=True
     bDisplayableInv=True
     PickupMessage="You got the Energy Amplifier"
     PickupMessageClass=Class'Botpack.PickupMessagePlus'
     RespawnTime=90.000000
     PickupViewMesh=LodMesh'UnrealShare.AmplifierM'
     Charge=1000
     MaxDesireability=1.200000
     PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
     ActivateSound=Sound'UnrealShare.Pickups.HEALTH1'
     Icon=Texture'UnrealShare.Icons.I_Amp'
     Mesh=LodMesh'UnrealShare.AmplifierM'
     CollisionRadius=20.000000
     CollisionHeight=13.500000
}
